/*
 * Copyright 1999-2019 Alibaba Group Holding Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.chaosblade.exec.bootstrap.jvmsandbox;

/**
 * @author Changjun Xiao
 */
public class BeforeEventBean {

    private ClassLoader classLoader;
    private Object object;
    private String className;
    private String methodName;
    private String methodDesc;
    private Object[] argumentArray;

    public BeforeEventBean(ClassLoader classLoader, Object object, String className, String methodName,
                           String methodDesc, Object[] argumentArray) {
        this.classLoader = classLoader;
        this.object = object;
        this.className = className;
        this.methodName = methodName;
        this.methodDesc = methodDesc;
        this.argumentArray = argumentArray;
    }

    public ClassLoader getClassLoader() {
        return classLoader;
    }

    public Object getObject() {
        return object;
    }

    public String getClassName() {
        return className;
    }

    public String getMethodName() {
        return methodName;
    }

    public String getMethodDesc() {
        return methodDesc;
    }

    public Object[] getArgumentArray() {
        return argumentArray;
    }
}
